Index: GTP/trunk/App/Demos/Illum/Shark3D/version164x12u/CleanTheLab/src/res/levelutil/shader/prog/.sconsign
===================================================================
--- GTP/trunk/App/Demos/Illum/Shark3D/version164x12u/CleanTheLab/src/res/levelutil/shader/prog/.sconsign	(revision 2453)
+++ GTP/trunk/App/Demos/Illum/Shark3D/version164x12u/CleanTheLab/src/res/levelutil/shader/prog/.sconsign	(revision 2486)
@@ -1,15 +1,57 @@
-}q(U*gen_brightmap_for_softshmap.s3d_shaderprogq(cSCons.Node.FS
+}q(U!gtp_envmap_refract.s3d_shaderprogq(cSCons.Node.FS
 BuildInfo
-qoq}q(U	timestampqJÉEeFUcsigqJÉEeFubU
-gen_brightclear.s3d_shaderprogq(hoq	}q
-(hJÉEeFhJÉEeFubUblack.s3d_shaderprogq
-(hoq
+qoq}q(U	timestampqJRnFUcsigqJRnFubU*gen_brightmap_for_softshmap.s3d_shaderprogq(hoq	}q
+(U	timestampq
+JÉEeFUcsigq
+JÉEeFubU
+gen_brightclear.s3d_shaderprogq
+(hoq}q(h
+JÉEeFh
+JÉEeFubUblack.s3d_shaderprogq(hoq}q(h
+JÉEeFh
+JÉEeFubU"gtp_caustic_recieve.s3d_shaderprogq(hoq}q(U	timestampqJÉEeFUcsigqJÉEeFubU(gtp_caustic_cubemap_point.s3d_shaderprogq(hoq}q(hJÉEeFhJÉEeFubU$gtp_distance_impostor.s3d_shaderprogq(hoq
 }q
-(hJÉEeFhJÉEeFubU"gtp_caustic_recieve.s3d_shaderprogq(hoq}q(U	timestampqJÉEeFUcsigqJÉEeFubUbloom_smooth.s3d_shaderprogq(hoq}q(hJÉEeFhJÉEeFubU$gtp_distance_impostor.s3d_shaderprogq(hoq}q(U	timestampqJÉEeFUcsigqJÉEeFubUbump.s3d_shaderprogq(hoq
-}q
-(hJÉEeFhJÉEeFubUgen_shmap.s3d_shaderprogq
-(hoq}q (hJÉEeFhJÉEeFubUbloom_bright.s3d_shaderprogq!(hoq"}q#(hJÉEeFhJÉEeFubU
-plain_pointtex.s3d_shaderprogq$(hoq%}q&(hJÉEeFhJÉEeFubU(gtp_caustic_cubemap_point.s3d_shaderprogq'(hoq(}q)(hJÉEeFhJÉEeFubUpartic.s3d_shaderprogq*(hoq+}q,(hJÉEeFhJÉEeFubUlightfilter.s3d_shaderprogq-(hoq.}q/(hJÉEeFhJÉEeFubU plain_pointcoltex.s3d_shaderprogq0(hoq1}q2(hJÉEeFhJÉEeFubU
-bloom_combine.s3d_shaderprogq3(hoq4}q5(hJÉEeFhJÉEeFubU!gtp_reduce_cubemap.s3d_shaderprogq6(hoq7}q8(hJÉEeFhJÉEeFubUgen_shvol_strict.s3d_shaderprogq9(hoq:}q;(hJÉEeFhJÉEeFubU%bloom_presmooth_bright.s3d_shaderprogq<(hoq=}q>(hJÉEeFhJÉEeFubUstandard.s3d_shaderprogq?(hoq@}qA(hJÉEeFhJÉEeFubUbump_bright.s3d_shaderprogqB(hoqC}qD(hJÉEeFhJÉEeFubUbump_shmap.s3d_shaderprogqE(hoqF}qG(hJÉEeFhJÉEeFubU gtp_cau_photonmap.s3d_shaderprogqH(hoqI}qJ(hJÉEeFhJÉEeFubUplain_point.s3d_shaderprogqK(hoqL}qM(hJÉEeFhJÉEeFubUcomic.s3d_shaderprogqN(hoqO}qP(hJÉEeFhJÉEeFubU
-gen_shvol_quick.s3d_shaderprogqQ(hoqR}qS(hJÉEeFhJÉEeFubUgtp_envmap.s3d_shaderprogqT(hoqU}qV(hJÉEeFhJÉEeFubUgtp_diffuse.s3d_shaderprogqW(hoqX}qY(hJÉEeFhJÉEeFubUbump_mild.s3d_shaderprogqZ(hoq[}q\(hJÉEeFhJÉEeFubU
-plain_pointcol.s3d_shaderprogq](hoq^}q_(hJÉEeFhJÉEeFubu.
+(U	timestampq
+JÉEeFUcsigqJÉEeFubUbump.s3d_shaderprogq (hoq!}q"(h
+JÉEeFh
+JÉEeFubUgen_shmap.s3d_shaderprogq#(hoq$}q%(h
+JÉEeFh
+JÉEeFubUbloom_bright.s3d_shaderprogq&(hoq'}q((h
+JÉEeFh
+JÉEeFubU
+plain_pointtex.s3d_shaderprogq)(hoq*}q+(h
+JÉEeFh
+JÉEeFubUbloom_smooth.s3d_shaderprogq,(hoq-}q.(h
+JÉEeFh
+JÉEeFubUpartic.s3d_shaderprogq/(hoq0}q1(h
+JÉEeFh
+JÉEeFubUlightfilter.s3d_shaderprogq2(hoq3}q4(h
+JÉEeFh
+JÉEeFubU plain_pointcoltex.s3d_shaderprogq5(hoq6}q7(h
+JÉEeFh
+JÉEeFubU
+bloom_combine.s3d_shaderprogq8(hoq9}q:(h
+JÉEeFh
+JÉEeFubU!gtp_reduce_cubemap.s3d_shaderprogq;(hoq<}q=(hJÉEeFhJÉEeFubUgen_shvol_strict.s3d_shaderprogq>(hoq?}q@(h
+JÉEeFh
+JÉEeFubU%bloom_presmooth_bright.s3d_shaderprogqA(hoqB}qC(h
+JÉEeFh
+JÉEeFubUstandard.s3d_shaderprogqD(hoqE}qF(h
+JÉEeFh
+JÉEeFubUbump_bright.s3d_shaderprogqG(hoqH}qI(h
+JÉEeFh
+JÉEeFubUbump_shmap.s3d_shaderprogqJ(hoqK}qL(h
+JÉEeFh
+JÉEeFubU gtp_cau_photonmap.s3d_shaderprogqM(hoqN}qO(hJÉEeFhJÉEeFubUplain_point.s3d_shaderprogqP(hoqQ}qR(h
+JÉEeFh
+JÉEeFubUcomic.s3d_shaderprogqS(hoqT}qU(h
+JÉEeFh
+JÉEeFubU
+gen_shvol_quick.s3d_shaderprogqV(hoqW}qX(h
+JÉEeFh
+JÉEeFubUgtp_envmap.s3d_shaderprogqY(hoqZ}q[(hJÉEeFhJÉEeFubUgtp_diffuse.s3d_shaderprogq\(hoq]}q^(hJÉEeFhJÉEeFubUbump_mild.s3d_shaderprogq_(hoq`}qa(h
+JÉEeFh
+JÉEeFubU
+plain_pointcol.s3d_shaderprogqb(hoqc}qd(h
+JÉEeFh
+JÉEeFubUgtp_envmap_metal.s3d_shaderprogqe(hoqf}qg(hJ¡nFhJ¡nFubu.